DL_SignatureSchemeBase< INTERFACE, KEY_INTERFACE > Class Template Referenceabstract

Discrete Log (DL) signature scheme base implementation. More...

Inheritance diagram for DL_SignatureSchemeBase< INTERFACE, KEY_INTERFACE >:

## Public Member Functions

size_t | SignatureLength () const
| Provides the signature length. More...
size_t | MaxRecoverableLength () const
| Provides the maximum recoverable length. More...
size_t | MaxRecoverableLengthFromSignatureLength (size_t signatureLength) const
| Provides the maximum recoverable length. More...
bool | IsProbabilistic () const
| Determines if the scheme is probabilistic. More...
bool | AllowNonrecoverablePart () const
| Determines if the scheme has non-recoverable part. More...
bool | RecoverablePartFirst () const
| Determines if the scheme allows recoverable part first. More...

## Detailed Description

### template<class INTERFACE, class KEY_INTERFACE>
class DL_SignatureSchemeBase< INTERFACE, KEY_INTERFACE >

Discrete Log (DL) signature scheme base implementation.

Template Parameters

  INTERFACE | PK_Signer or PK_Verifier derived class
  DL_Base | key base used in the scheme

DL_SignatureSchemeBase provides common functions for signers and verifiers. DL_Base<DL_PrivateKey> is used for signers, and DL_Base<DL_PublicKey> is used for verifiers.

Definition at line 1390 of file pubkey.h.

## Member Function Documentation

## SignatureLength()

template<class INTERFACE , class KEY_INTERFACE >

size_t DL_SignatureSchemeBase< INTERFACE, KEY_INTERFACE >::SignatureLength | ( |  | ) | const

inline

Provides the signature length.

Returns
  signature length, in bytes

SignatureLength returns the size required for `r+s`.

Definition at line 1400 of file pubkey.h.

## MaxRecoverableLength()

template<class INTERFACE , class KEY_INTERFACE >

size_t DL_SignatureSchemeBase< INTERFACE, KEY_INTERFACE >::MaxRecoverableLength | ( |  | ) | const

inline

Provides the maximum recoverable length.

Returns
  maximum recoverable length, in bytes

Definition at line 1408 of file pubkey.h.

## MaxRecoverableLengthFromSignatureLength()

template<class INTERFACE , class KEY_INTERFACE >

size_t DL_SignatureSchemeBase< INTERFACE, KEY_INTERFACE >::MaxRecoverableLengthFromSignatureLength | ( | size_t | signatureLength | ) | const

inline

Provides the maximum recoverable length.

Parameters

  signatureLength | the size fo the signature

Returns
  maximum recoverable length based on signature length, in bytes

this function is not implemented and always returns 0.

Definition at line 1415 of file pubkey.h.

## IsProbabilistic()

template<class INTERFACE , class KEY_INTERFACE >

bool DL_SignatureSchemeBase< INTERFACE, KEY_INTERFACE >::IsProbabilistic | ( |  | ) | const

inline

Determines if the scheme is probabilistic.

Returns
  true if the scheme is probabilistic, false otherwise

Definition at line 1420 of file pubkey.h.

## AllowNonrecoverablePart()

template<class INTERFACE , class KEY_INTERFACE >

bool DL_SignatureSchemeBase< INTERFACE, KEY_INTERFACE >::AllowNonrecoverablePart | ( |  | ) | const

inline

Determines if the scheme has non-recoverable part.

Returns
  true if the message encoding has a non-recoverable part, false otherwise.

Definition at line 1425 of file pubkey.h.

## RecoverablePartFirst()

template<class INTERFACE , class KEY_INTERFACE >

bool DL_SignatureSchemeBase< INTERFACE, KEY_INTERFACE >::RecoverablePartFirst | ( |  | ) | const

inline

Determines if the scheme allows recoverable part first.

Returns
  true if the message encoding allows the recoverable part, false otherwise.

Definition at line 1430 of file pubkey.h.

The documentation for this class was generated from the following file:

- pubkey.h